
<div class="row">
 <div class="col-12 d-flex justify-content-between">
   <a href="/teaching/xml/xml"class="btn btn-primary" role="button">Langague XML </a>
  <a href="/teaching"class="btn btn-primary" role="button" >Sommaire </a>
<a href="/teaching/xml/xmlschema"class="btn btn-primary" role="button" >XMLSchema </a> 
 </div>
</div>
<h1><%= title %> </h1>
      <h2>Vocabulaires</h2>
      <hr/>
      <ul>
        <li> Un document avec une syntax correct est "bien formé".</li>
        <li>Un document bien formé et qui est aussi validé par une DTD est "valide".</li>
      </ul>

  <h2>Quand l'Utiliser</h2>
  <hr>
    <ul>
     <li>Création d'un standard.</li>
     <li>Facilitation de communication.</li>
     <li>Vérification de données reçu.</li>
    </ul>

  <h2>Quand ne pas l'Utiliser</h2>
  <hr>

 Pour des document xml simple.
  <br/>
  <br/>
  <br/>
<h2>Declaration</h2>
<hr/> 
  <pre><code>&lt;!DOCTYPE *NomElement* [ *<i>reste du code</i>*] &gt;</code></pre> 
  <p>Défini un Element racine (le même que celui du document xml)</p>
 <h3>Interne</h3>
<pre><code>
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;!DOCTYPE note [
	.
	.
	.
]&gt; 

&lt;note&gt;
&lt;to&gt;Tove&lt;/to&gt;
&lt;from&gt;Jani&lt;/from&gt;
&lt;heading&gt;Reminder&lt;/heading&gt;
&lt;body&gt;Don't forget me this weekend!&lt;/body&gt;
&lt;/note&gt;
</code></pre>

    <h3>Externe</h3>
  <pre><code>
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;!DOCTYPE note SYSTEM "Note.dtd"&gt;
&lt;note&gt;
&lt;to&gt;Tove&lt;/to&gt;
&lt;from&gt;Jani&lt;/from&gt;
&lt;heading&gt;Reminder&lt;/heading&gt;
&lt;body&gt;Don't forget me this weekend!&lt;/body&gt;
&lt;/note&gt;
  </code></pre>
    <p>La déclaration du document DTD est effectué par la balise<br/>
  
		<pre><code>&lt;!DOCTYPE note SYSTEM "Note.dtd"&gt;</code></pre>

  <b>Note.dtd:</b>
  </p>
   <pre><code>
&lt;&#33;ELEMENT note (to, from, heading, body)&gt;
  &lt;&#33;ELEMENT to (&#35;PCDATA)&gt;
  &lt;&#33;ELEMENT from (&#35;PCDATA)&gt;
  &lt;&#33;ELEMENT heading (&#35;PCDATA)&gt;
  &lt;&#33;ELEMENT body (&#35;PCDATA)&gt;
   </code></pre>
 <div class="alert alert-info" role="alert">
  A noter que la déclaration du doctype n'est pas nécessaire dans ce fichier.</div>


    <h2>Blocs structurants</h2>
    <hr>
    	<p>Il existe 5 blocs structurants autorisé :</p>
    <h3>#PCDATA</h3>
	 	<i>(parse-able text data)</i> , correspond à une valeur entre les balises.
	
    <h3>#CDATA</h3>
		 <i>(character data)</i> , correspond généralement à la valeur d'un attribut.
   
    <h3>ELEMENT</h3>
         Les éléments sont définis par le mot-clef <i>!ELEMENT</i> et leurs categories:
		<pre><code>&lt;!ELEMENT *<i>NomElement</i>* category&gt; </pre></code>
		ou leur contenu ...
		<pre><code>&lt;!ELEMENT *<i>NomElement</i>* (content)&gt; </pre></code>
		les éléments vide sont déclarés avec le mot-clef <i>EMPTY</i>  ...
		<pre><code>&lt;!ELEMENT *<i>NomElement</i>* EMPTY&gt; </pre></code>
		<b>PCDATA</b><br/>
		les éléments uniquement composés de PCDATA sont délcarés avec (#PCDATA)
		<pre><code>&lt;!ELEMENT *<i>NomElement</i>* (#PCDATA)&gt; </pre></code>
		
		<b>Enfants</b><br/>

			Les éléments ayant un ou plusieurs enfant(s), sont déclarés entre parenthèses:
		<pre><code>&lt;!ELEMENT *<i>NomElement</i>* (child)&gt; </pre></code>
			séparé par des "," si plusieurs:
		<pre><code>&lt;!ELEMENT *<i>NomElement</i>* (child1,child2,...)&gt; </pre></code>
 		<b>Exemple</b><br/>
<pre><code>
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;!DOCTYPE note [
	&lt;!ELEMENT note (auteur, message) &gt;
	&lt;!ELEMENT auteur (&#35PCDATA) &gt;
	&lt;!ELEMENT message (&#35PCDATA) &gt;
]&gt; 

&lt;note&gt;
	&lt;auteur&gt;MOI&lt;/auteur&gt;
	&lt;message&gt;Don't forget me this weekend!&lt;/message&gt;
&lt;/note&gt;
</code></pre>
		<div class="alert alert-info" role="alert">
  			Les éléments enfants de la séquence devront être définis dans le même ordre dans la suite du DTD. 
		</div>
		<b>Cardinalité</b><br/>
        Il existe 5 cardinalités pour les éléments enfants:
			 
 		<ul>
              <li> (child), une occurence de l'élément</li>
              <li> (child<b>+</b>), au moins une occurence de l'élément</li>
              <li> (child<b>?</b>), zéro ou une d'occurence de l'élément</li>
              <li> (child<b>*</b>), zéro ou plus d'occurences de l'élément</li>
              <li> (child1<b>|</b>child2), soit l'élement 1 soit l'élément 2</li>
        </ul>
		<h2>Attribut</h2>
			<b>Déclaration</b><br/>
			déclaration d'un attribut par le mot-clef <i>ATTLIST</i> suivi de:
			<ul>
				<li>Le nom de l'élément auquel il est rattaché</li>
				<li>Le nom de l'attribut</li>
				<li>Son type</li>
				<li>Sa valeur</li>
			</ul>
 			<pre><code>&lt;!ATTLIST *NomElement* *NomAttribut* *TypeAttribut* *ValeurAttribut*&gt;</pre></code>
			
        	<b>Types</b><br/>
				<table class="table">
					<tr>
						<td>CDATA</td>
						<td>Character data</td>
					</tr>
					<tr>
						<td>(a|b|c|...) "defaultValue"</td>
						<td>Enumeration avec une valeur par défaut</td>
					</tr>
					<tr>
						<td>ID</td>
						<td>Identifiant unique</td>
					</tr>
					<tr>
						<td>IDREF</td>
						<td>Référence sur un autre élément</td>
					</tr>
					<tr>
						<td>...</td>
						<td> <a href="https://www.w3schools.com/xml/xml_dtd_attributes.asp">liste complete</a></td>
					</tr>
				</table>
			<b>Valeurs</b><br/>		
				<table class="table">
					<tr>
						<td>"Value"</td>
						<td>valeur par défaut</td>
					</tr>
					<tr>
						<td>#REQUIRED</td>
						<td>valeur obligatoire</td>
					</tr>
					<tr>
						<td>#IMPLIED</td>
						<td>valeur optionnelle</td>
					</tr>
					<tr>
						<td>#FIXED value</td>
						<td>valeur fixe (ie constante)</td>
					</tr>
				</table>
	<br/>
	<br/>
      <h2>Exemple complet : </h2>
	  <hr/>
      <pre><code>
&lt;!DOCTYPE livre [
    &lt;!ELEMENT livre (titre,auteur+,genre*,edition)&gt;
      &lt;!ATTLIST livre ISBN CDATA #REQUIRED&gt;
      &lt;!ATTLIST livre Support (papier|numérique) "papier" &gt;
    &lt;!ELEMENT titre (#PCDATA)&gt;
    &lt;!ELEMENT auteur (#PCDATA)&gt;
    &lt;!ELEMENT genre (#PCDATA)&gt;
    &lt;!ELEMENT edition (#PCDATA)&gt;
      &lt;!ATTLIST edition originale CDATA #IMPLIED&gt;
]&gt;
  </code></pre>
  </p>
	
  <h2>Entité</h2>
	<hr/>
	Equivalent à un racourci, on le déclare avec la syntaxe:
	<pre><code>&lt;!ENTITY name "value"&gt;</code></pre>
	
  <div class="alert alert-info" role="alert">On utilise &name; dans le XML </div>
	<pre><code>
&lt;!ENTITY ISIDIS "promo 2019 ISIDIS"&gt;
	...
&lt;module&gt;
	&lt;libelle&gt;Web service &lt;/libelle&gt;
	&lt;promotion&gt; &ISIDIS; &lt;/promotion&gt;
&lt;/module&gt;
	</code></pre>
	
  <br/>
  <br/>
  <br/>
<div class="row">
 <div class="col-12 d-flex justify-content-between">
   <a href="/teaching/xml/xml"class="btn btn-primary" role="button">Langague XML </a>
  <a href="/teaching"class="btn btn-primary" role="button" >Sommaire </a>
<a href="/teaching/xml/xmlschema"class="btn btn-primary" role="button" >XMLSchema </a> 
 </div>
</div>
